﻿using System;
using System.Threading.Tasks;

using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.executeButton.Click += executeButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 실행 버튼 클릭시 처리하기 - executeButton_Click(sender, e)

        /// <summary>
        /// 실행 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void executeButton_Click(object sender, EventArgs e)
        {
            OverlayFormHelper helper = new OverlayFormHelper(this.rootTableLayoutPanel, Font, ForeColor, true);

            try
            {
                helper.Show();

                await Task.Run
                (
                    () => {

                        for(int i = 0; i < 30; i++)
                        {
                            helper.SetMessage($"데이터를 로드하고 있습니다. ({i}/30)");

                            System.Threading.Thread.Sleep(500);

                            if(helper.IsCancelled)
                            {
                                XtraMessageBox.Show(this, "작업 취소");

                                return;
                            }
                        }
                    }
                );
            }
            finally
            {
                helper.Close();
            }
        }

        #endregion
    }
}